

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <string>

using namespace std;

void generarOperadores(int &op1, int  &op2, int difficultad);
bool hacerPregunta(int nivel);
int gen_rand(int dificultad);
void progreso(int &nivel,int &dificultad,bool modo,int &puntos, int maximaDificultad);
void marcador(int,int,int);
void temporizador();
bool quedaTiempo(time_t,double);



const int PUNTOSCRACK = 4000;
const int PUNTOSMALO  = 900;

int main(void) {
  int maximaDificultad;
  time_t start,current;
  double maximoDefinido;
  int nivel=1;
  int dificultad=1;
  int puntos=0;

  system("clear");
  cout << "Antes de empezar... " <<endl;
  sleep(1);
  cout << "cuantos segundos quieres que dure la prueba ? " << endl;
  cin >>maximoDefinido;
  cout << "cuantos preguntas correctas para pasar de nivel ? " << endl;
  cin  >> maximaDificultad;


  time (&start);

  system("clear");

  while(quedaTiempo(start,maximoDefinido))
  {
	marcador(nivel,dificultad, puntos);
	cout <<endl<<endl;
	progreso(nivel,dificultad,hacerPregunta(nivel),puntos,maximaDificultad);
	system("clear");
   }

	cout << " Tiempo !!  "<< endl;
	sleep(1);
	cout << " tengo que decirte que ... "<< endl;

	if(puntos >= PUNTOSCRACK)
		cout << ":) Que eres un Crack !!! " << endl;
	else if(nivel ==1)
		cout << "Ufff .. tienes que trabajar duro amigo  " << endl;
	else
		cout << " sigue as con la practica tu cerebro crecera hata que no entres por la puerta"<<endl;
	sleep(1);
	cout << endl;
	cout << "----------------------------"<<endl;
	cout << "- NIVEL ALCANZADO : "<< nivel <<endl;
	cout << "- DIFICULTAD ALCANZADA : "<< nivel <<endl;
	cout << "- PUNTUACION : "<< puntos <<endl;
}

bool quedaTiempo(time_t start,double maximoDefinido )
{
	time_t end;
	double dif;

	time (&end);
	dif = difftime (end,start);
	cout << "TIEMPO: " << dif << " segundos || "<< (maximoDefinido-dif) << " restantes " << endl;
 	return (dif <   maximoDefinido );
}


void marcador(int nivel ,int dif, int puntos)
{
	cout << "------------------------------------"<<endl;
	cout << "-----NIVEL:"<< nivel <<"---DIFICULTAD:"<< dif<<"-----"<<endl;
	cout << "--- " << puntos << " pts"<<endl;
	cout << "------------------------------------"<<endl;



}

bool hacerPregunta(int nivel)
{
	int op1, op2, result, respuesta;  //operador 1 operador 2 , resultado

	generarOperadores(op1,op2, nivel);

	switch( nivel)
	{
		case 1:
			cout << op1 << " + " << op2 << " = " ;
			cin >> respuesta;
			if(op1+op2==respuesta){ cout << " OK\a"<<endl; result =true; }
			else{ cout <<" X"<<endl;  result =false; }
		break;
		case 2:
			cout << op1 << " - " << op2 << " = " ;
			cin >> respuesta;
			if(op1-op2==respuesta){ cout << " OK\a"<<endl; result =true; }
			else{ cout <<" X"<<endl;  result =false; }
		break;

		case 3:
			cout << op1 << " * " << op2  << " = " ;
			cin >> respuesta;
			if(op1*op2==respuesta){ cout << " OK\a "<<endl; result =true; }
			else{ cout <<" X" << endl;  result =false; }
		break;
	}
	return result;
}

void generarOperadores(int &op1, int  &op2, int dificultad)
{
	 srand((unsigned)time(0));
	 dificultad = dificultad * (10 ^dificultad);
	 op1=rand()%dificultad;
	 op2= rand()%dificultad;
}

void progreso(int &nivel,int &dificultad,bool modo,int &puntos,int maximaDificultad)
{
	if(modo)
	{
		puntos+=100; // 100 puntos por contestar bien

		dificultad++;
		if(dificultad>maximaDificultad) {
			dificultad=1;
			nivel++;
			puntos+=1000; // ms 1000 puntos por subir de nivel
		}

	}else{
		if(dificultad>1 && nivel >=1)
		{
			dificultad --;
		}
		else if(dificultad==1 && nivel >1)
		{
			dificultad = maximaDificultad;
			nivel --;
		}
	}
}




